# -*- coding: utf-8 -*-

"""
spotifywebapi

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from spotifywebapi.api_helper import APIHelper
from spotifywebapi.models.episode_restriction_object import EpisodeRestrictionObject
from spotifywebapi.models.external_url_object import ExternalUrlObject
from spotifywebapi.models.image_object import ImageObject
from spotifywebapi.models.resume_point_object import ResumePointObject


class EpisodeBase(object):

    """Implementation of the 'EpisodeBase' model.

    TODO: type model description here.

    Attributes:
        audio_preview_url (str): A URL to a 30 second preview (MP3 format) of
            the episode. `null` if not available.
        description (str): A description of the episode. HTML tags are
            stripped away from this field, use `html_description` field in
            case HTML tags are needed.
        html_description (str): A description of the episode. This field may
            contain HTML tags.
        duration_ms (int): The episode length in milliseconds.
        explicit (bool): Whether or not the episode has explicit content (true
            = yes it does; false = no it does not OR unknown).
        external_urls (ExternalUrlObject): External URLs for this episode.
        href (str): A link to the Web API endpoint providing full details of
            the episode.
        id (str): The [Spotify
            ID](/documentation/web-api/concepts/spotify-uris-ids) for the
            episode.
        images (List[ImageObject]): The cover art for the episode in various
            sizes, widest first.
        is_externally_hosted (bool): True if the episode is hosted outside of
            Spotify's CDN.
        is_playable (bool): True if the episode is playable in the given
            market. Otherwise false.
        language (str): The language used in the episode, identified by a [ISO
            639](https://en.wikipedia.org/wiki/ISO_639) code. This field is
            deprecated and might be removed in the future. Please use the
            `languages` field instead.
        languages (List[str]): A list of the languages used in the episode,
            identified by their [ISO
            639-1](https://en.wikipedia.org/wiki/ISO_639) code.
        name (str): The name of the episode.
        release_date (str): The date the episode was first released, for
            example `"1981-12-15"`. Depending on the precision, it might be
            shown as `"1981"` or `"1981-12"`.
        release_date_precision (ReleaseDatePrecisionEnum): The precision with
            which `release_date` value is known.
        resume_point (ResumePointObject): The user's most recent position in
            the episode. Set if the supplied access token is a user token and
            has the scope 'user-read-playback-position'.
        mtype (Type8Enum): The object type.
        uri (str): The [Spotify
            URI](/documentation/web-api/concepts/spotify-uris-ids) for the
            episode.
        restrictions (EpisodeRestrictionObject): Included in the response when
            a content restriction is applied.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "audio_preview_url": 'audio_preview_url',
        "description": 'description',
        "html_description": 'html_description',
        "duration_ms": 'duration_ms',
        "explicit": 'explicit',
        "external_urls": 'external_urls',
        "href": 'href',
        "id": 'id',
        "images": 'images',
        "is_externally_hosted": 'is_externally_hosted',
        "is_playable": 'is_playable',
        "languages": 'languages',
        "name": 'name',
        "release_date": 'release_date',
        "release_date_precision": 'release_date_precision',
        "mtype": 'type',
        "uri": 'uri',
        "language": 'language',
        "resume_point": 'resume_point',
        "restrictions": 'restrictions'
    }

    _optionals = [
        'language',
        'resume_point',
        'restrictions',
    ]

    _nullables = [
        'audio_preview_url',
    ]

    def __init__(self,
                 audio_preview_url=None,
                 description=None,
                 html_description=None,
                 duration_ms=None,
                 explicit=None,
                 external_urls=None,
                 href=None,
                 id=None,
                 images=None,
                 is_externally_hosted=None,
                 is_playable=None,
                 languages=None,
                 name=None,
                 release_date=None,
                 release_date_precision=None,
                 mtype=None,
                 uri=None,
                 language=APIHelper.SKIP,
                 resume_point=APIHelper.SKIP,
                 restrictions=APIHelper.SKIP):
        """Constructor for the EpisodeBase class"""

        # Initialize members of the class
        self.audio_preview_url = audio_preview_url 
        self.description = description 
        self.html_description = html_description 
        self.duration_ms = duration_ms 
        self.explicit = explicit 
        self.external_urls = external_urls 
        self.href = href 
        self.id = id 
        self.images = images 
        self.is_externally_hosted = is_externally_hosted 
        self.is_playable = is_playable 
        if language is not APIHelper.SKIP:
            self.language = language 
        self.languages = languages 
        self.name = name 
        self.release_date = release_date 
        self.release_date_precision = release_date_precision 
        if resume_point is not APIHelper.SKIP:
            self.resume_point = resume_point 
        self.mtype = mtype 
        self.uri = uri 
        if restrictions is not APIHelper.SKIP:
            self.restrictions = restrictions 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if dictionary is None:
            return None

        # Extract variables from the dictionary
        audio_preview_url = dictionary.get("audio_preview_url") if dictionary.get("audio_preview_url") else None
        description = dictionary.get("description") if dictionary.get("description") else None
        html_description = dictionary.get("html_description") if dictionary.get("html_description") else None
        duration_ms = dictionary.get("duration_ms") if dictionary.get("duration_ms") else None
        explicit = dictionary.get("explicit") if "explicit" in dictionary.keys() else None
        external_urls = ExternalUrlObject.from_dictionary(dictionary.get('external_urls')) if dictionary.get('external_urls') else None
        href = dictionary.get("href") if dictionary.get("href") else None
        id = dictionary.get("id") if dictionary.get("id") else None
        images = None
        if dictionary.get('images') is not None:
            images = [ImageObject.from_dictionary(x) for x in dictionary.get('images')]
        is_externally_hosted = dictionary.get("is_externally_hosted") if "is_externally_hosted" in dictionary.keys() else None
        is_playable = dictionary.get("is_playable") if "is_playable" in dictionary.keys() else None
        languages = dictionary.get("languages") if dictionary.get("languages") else None
        name = dictionary.get("name") if dictionary.get("name") else None
        release_date = dictionary.get("release_date") if dictionary.get("release_date") else None
        release_date_precision = dictionary.get("release_date_precision") if dictionary.get("release_date_precision") else None
        mtype = dictionary.get("type") if dictionary.get("type") else None
        uri = dictionary.get("uri") if dictionary.get("uri") else None
        language = dictionary.get("language") if dictionary.get("language") else APIHelper.SKIP
        resume_point = ResumePointObject.from_dictionary(dictionary.get('resume_point')) if 'resume_point' in dictionary.keys() else APIHelper.SKIP
        restrictions = EpisodeRestrictionObject.from_dictionary(dictionary.get('restrictions')) if 'restrictions' in dictionary.keys() else APIHelper.SKIP
        # Return an object of this model
        return cls(audio_preview_url,
                   description,
                   html_description,
                   duration_ms,
                   explicit,
                   external_urls,
                   href,
                   id,
                   images,
                   is_externally_hosted,
                   is_playable,
                   languages,
                   name,
                   release_date,
                   release_date_precision,
                   mtype,
                   uri,
                   language,
                   resume_point,
                   restrictions)
