# -*- coding: utf-8 -*-

"""
spotifywebapi

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from spotifywebapi.api_helper import APIHelper
from spotifywebapi.models.playlist_user_object import PlaylistUserObject


class PlaylistTrackObject(object):

    """Implementation of the 'PlaylistTrackObject' model.

    TODO: type model description here.

    Attributes:
        added_at (datetime): The date and time the track or episode was added.
            _**Note**: some very old playlists may return `null` in this
            field._
        added_by (PlaylistUserObject): The Spotify user who added the track or
            episode. _**Note**: some very old playlists may return `null` in
            this field._
        is_local (bool): Whether this track or episode is a [local
            file](/documentation/web-api/concepts/playlists/#local-files) or
            not.
        track (object): Information about the track or episode.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "added_at": 'added_at',
        "added_by": 'added_by',
        "is_local": 'is_local',
        "track": 'track'
    }

    _optionals = [
        'added_at',
        'added_by',
        'is_local',
        'track',
    ]

    def __init__(self,
                 added_at=APIHelper.SKIP,
                 added_by=APIHelper.SKIP,
                 is_local=APIHelper.SKIP,
                 track=APIHelper.SKIP):
        """Constructor for the PlaylistTrackObject class"""

        # Initialize members of the class
        if added_at is not APIHelper.SKIP:
            self.added_at = APIHelper.apply_datetime_converter(added_at, APIHelper.RFC3339DateTime) if added_at else None 
        if added_by is not APIHelper.SKIP:
            self.added_by = added_by 
        if is_local is not APIHelper.SKIP:
            self.is_local = is_local 
        if track is not APIHelper.SKIP:
            self.track = track 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if dictionary is None:
            return None

        # Extract variables from the dictionary
        added_at = APIHelper.RFC3339DateTime.from_value(dictionary.get("added_at")).datetime if dictionary.get("added_at") else APIHelper.SKIP
        added_by = PlaylistUserObject.from_dictionary(dictionary.get('added_by')) if 'added_by' in dictionary.keys() else APIHelper.SKIP
        is_local = dictionary.get("is_local") if "is_local" in dictionary.keys() else APIHelper.SKIP
        track = dictionary.get("track") if dictionary.get("track") else APIHelper.SKIP
        # Return an object of this model
        return cls(added_at,
                   added_by,
                   is_local,
                   track)
