# -*- coding: utf-8 -*-

"""
spotifywebapi

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from spotifywebapi.api_helper import APIHelper


class PlaylistsRequest(object):

    """Implementation of the 'Playlists Request' model.

    TODO: type model description here.

    Attributes:
        name (str): The new name for the playlist, for example `"My New
            Playlist Title"`
        public (bool): If `true` the playlist will be public, if `false` it
            will be private.
        collaborative (bool): If `true`, the playlist will become
            collaborative and other users will be able to modify the playlist
            in their Spotify client. <br/> _**Note**: You can only set
            `collaborative` to `true` on non-public playlists._
        description (str): Value for playlist description as displayed in
            Spotify Clients and in the Web API.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "name": 'name',
        "public": 'public',
        "collaborative": 'collaborative',
        "description": 'description'
    }

    _optionals = [
        'name',
        'public',
        'collaborative',
        'description',
    ]

    def __init__(self,
                 name=APIHelper.SKIP,
                 public=APIHelper.SKIP,
                 collaborative=APIHelper.SKIP,
                 description=APIHelper.SKIP):
        """Constructor for the PlaylistsRequest class"""

        # Initialize members of the class
        if name is not APIHelper.SKIP:
            self.name = name 
        if public is not APIHelper.SKIP:
            self.public = public 
        if collaborative is not APIHelper.SKIP:
            self.collaborative = collaborative 
        if description is not APIHelper.SKIP:
            self.description = description 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if dictionary is None:
            return None

        # Extract variables from the dictionary
        name = dictionary.get("name") if dictionary.get("name") else APIHelper.SKIP
        public = dictionary.get("public") if "public" in dictionary.keys() else APIHelper.SKIP
        collaborative = dictionary.get("collaborative") if "collaborative" in dictionary.keys() else APIHelper.SKIP
        description = dictionary.get("description") if dictionary.get("description") else APIHelper.SKIP
        # Return an object of this model
        return cls(name,
                   public,
                   collaborative,
                   description)
